#include "Tlc5940.h"  //import the tlc library
#include "tlc_servos.h" //Import the servo library for the tlc.

int servoL = 0; // servo position varibles
int servoR = 0; 

int lightpwms[42]; // a array that will hold all of the pwm values of the leds for the mouth and the eyes. values are 0-4095. 0 is off. 4095 is full on.

#define SERVO_CHANNELL   43 //Define servo pin in library.
#define SERVO_CHANNELR   44 // define servo pin in library.

char serial[20]; //word string from serial.
char transitchar; //1 character from serial.
int i = 0;

int firstnumber = 0;
int secondnumber = 0;
int power = 0;
int lednumber = 0;


void setup() {
  
//pinMode(switchpin, INPUT); //set the switchpin as input
//pinMode(terminatebutton, INPUT); //set the pin as input
Serial.begin(9600);	// opens serial port, sets data rate to 9600 bps
Tlc.init(); // init the tlc's
tlc_initServos();  // Note: this will drop the PWM freqency down to 50Hz.
delay(20);//wait a bit before proceding
behappy(); //be happy!!1
linemouth(); //It needs a mouth!
Serial.println("Ready");


} //end of setup



void loop(){
delay(500);
  if (Serial.available() > 0) { //if there is stuff in the serial buffer, Get it!
 delay(50);
  while (Serial.available() > 0) { //Get the word!
   transitchar = Serial.read();
   if (transitchar != ' ') {
    serial[i] = transitchar; 
    i++;
   } else {
    checkforsubandpassrest();
     } //end of "if transitchar = ' '"
 }//end of while serial.available
  checkforsubandpassrest();
  //Serial.println("");
}//end of if serial.available
  
} //end main loop


void checkforsubandpassrest() {
  if (strcmp(serial, "behappy")  == 0) { //check if the word is... Don't you know that the bird is the word?
       behappy();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "setservos")  == 0) { //check if the word is... Everybody knows that the bird is the word!
       setservos();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "bemad")  == 0) { //check if the word is... Bird, bird, bird! Bird is the word!
       bemad();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "besad")  == 0) { //check if the word is
       besad();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "linemouth")  == 0) { //check if the word is
       linemouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "fullmouth")  == 0) { //check if the word is
       fullmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "offmouth")  == 0) { //check if the word is
       offmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "offeyes")  == 0) { //check if the word is
       offeyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "bluegreeneyes")  == 0) { //check if the word is
       bluegreeneyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "redeyes")  == 0) { //check if the word is
       redeyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "blueeyes")  == 0) { //check if the word is
       blueeyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "openmouth")  == 0) { //check if the word is
       openmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "talkmouth")  == 0) { //check if the word is
       talkmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "setleds")  == 0) { //check if the word is...
       //setleds();
      clearserial(); //clear serial
      i = 0; //reset
      } else {
       Serial.print(serial); 
       Serial.print(' ');
       clearserial();
       i = 0;
      }
  
}


void clearserial() {
for (int i = 0; i < 20; i++) {
serial[i] = '\0';
}  
}



void behappy() { //be happy!
  servoR = 75; //servo position
  servoL = 75;
  setservos();
  //tlc_setServo(SERVO_CHANNELR, servoR); //set the servos
  //tlc_setServo(SERVO_CHANNELL, servoL);
  //updatetlc(); //update
  //delay(10); //you need a delay after the update
  bluegreeneyes();
  } //end behappy
  
void setservos() {
  tlc_setServo(SERVO_CHANNELR, servoR); //set the servos
  tlc_setServo(SERVO_CHANNELL, servoL);
  updatetlc(); //update
}
  
void bemad() {
  servoR = 130;
  servoL = 130;
  setservos();
  redeyes();
}

void besad() {
 servoR = 30;
 servoL = 30;
 setservos();
 blueeyes();
}
  

void linemouth() {
// make a line mouth..
resetmouth();
for (int i = 0; i < 18; i++){
lightpwms[i + 9] = 4095;
}
updatetlc(); //update
} //end linemouth


void fullmouth() {
  resetmouth();
  for (int i = 0; i <= 35; i++) { // light up all the leds in the mouth to low.
    lightpwms[i] = 100; 
  }
  lightpwms[7] = 1500; // compensate for some burned leds.
  lightpwms[8] = 1000;
  lightpwms[27] = 1500; 
  updatetlc(); //update
} //end fullmouth


void offmouth() { // turns off the mouth leds.
 resetmouth(); //reset mouth.
 updatetlc();  //update.
} //end offmouth


void offeyes() { // turns off the eye leds.
 reseteyes();  //reset eyes.
 updatetlc();  //update.
} //end offeyes


void bluegreeneyes() { //bluegreeneyes
  reseteyes();
  lightpwms[38] = 4095; //eyes. this will achieve a blue-green color w/ full intensity.
  lightpwms[39] = 4095; //eyes
  lightpwms[40] = 4095; //eyes
  lightpwms[41] = 4095; //eyes
  //lightpwms[42] = 4095; //eyes 
  updatetlc(); //update
} //end bluegreeneyes

void redeyes() {
 reseteyes();
 lightpwms[36] = 4095;
 lightpwms[37] = 4095;
 updatetlc();
}

void blueeyes() {
 reseteyes();
 lightpwms[38] = 4095;
 lightpwms[39] = 4095;
 updatetlc();
}


void openmouth() {
  resetmouth();
  for (int i = 0; i < 9; i++) { // light up the top row.
    lightpwms[i] = 4095; 
  }
  for (int j = 27; j < 36; j++) { // light up the bottom row.
    lightpwms[j] = 4095;
   }
  updatetlc(); //update
  delay(10);
} //end openmouth


void resetmouth() { // reset the array for the mouth leds. does NOT update! use offmouth() to turn off mouth leds.
  for (int i = 0; i < 36; i++) { // erase!!
    lightpwms[i] = 0;
   } 
} //end resetmouth


void reseteyes() { // reset the array for the eye leds. does NOT update! use offeyes() to turn off eye leds.
  for (int i = 36; i < 42; i++) { // erase!!
    lightpwms[i] = 0;
   }
} //end reseteyes


void talkmouth() { //finished and debugged. will make a "sudo" talking mouth.
  linemouth();
  for (int i = 0; i <= 3; i++){ 
  openmouth();
  delay(400);
  linemouth();
  delay(400);
  } //end for loop
} //end talkmouth


void updatetlc() { //subroutine to update all leds.
 for (int j = 0; j < 42; j++) {
    Tlc.set(j, lightpwms[j]);
    }
 Tlc.update();
 delay(50); 
} //end updatetlc


/* these are the pin outs

Mouth:
  0  1  2  3  4  5  6  7  8
  9 10 11 12 13 14 15 16 17
  18 19 20 21 22 23 24 25 26
  27 28 29 30 31 32 33 34 35
  
  Eyes:
  
  L: R  G  B    R: R  G  B 
     36 40 38      37 41 39
*/
